<?php

@include_once dirname(__FILE__) . '/controls.php';

$plugin = $file_commerce_pro;

if (isset($_GET['id'])) {
    $controls->options = $wpdb->get_row($wpdb->prepare("select * from " . $wpdb->prefix . FILECOMMERCEPRO_TABLE_CONTRACTS . " where id=%d", $_GET['id']), ARRAY_A);
}

if ($controls->is_action('save')) {
        // Check fields validity
        $controls->options = stripslashes_deep($_POST['options']);
        $id = $controls->options['id'];
        unset($controls->options['id']);
        $wpdb->update($wpdb->prefix . FILECOMMERCEPRO_TABLE_CONTRACTS, $controls->options, array('id'=>$id));
        $controls->options = $wpdb->get_row($wpdb->prepare("select * from " . $wpdb->prefix . FILECOMMERCEPRO_TABLE_CONTRACTS . " where id=%d", $id), ARRAY_A);
        $controls->messages = 'Contract updated';
    }
?>

<div class="wrap">

    <h2><?php echo $plugin->title; ?>: Contract Edit</h2>

    <?php $controls->show_errors(); ?>
    <?php $controls->show_messages(); ?>
    
    <form method="post" action="">
        <?php $controls->init(); ?>
        <?php $controls->hidden('id'); ?>

        <table class="form-table">
            <tr valign="top">
                <th>User</th>
                <td>
                    <?php $u = get_user_by('id', $controls->options['userid']);?>
                    <?php echo $u->user_login; ?> - <?php echo $u->user_email; ?>
                </td>
            </tr>
            <tr valign="top">
                <th>File</th>
                <td>
                    <?php
                    $files = $wpdb->get_results("select id, title, duration from " . $wpdb->prefix . FILECOMMERCEPRO_TABLE_FILES . " order by title");
                    foreach($files as $file) {
                        $options['' . $file->id] = $file->title . ' (' . $file->duration . ' days)';
                    }
                    $controls->select(fileid, $options);
                    ?>
                </td>
            </tr>
            <tr valign="top">
                <th>Status</th>
                <td>
                    <?php $controls->select('status', array(FileCommercePro::CONTRACT_VALID=>'Valid', FileCommercePro::CONTRACT_INVALID=>'Invalid')); ?>
                </td>
            </tr>
            <tr valign="top">
                <th>Expire on</th>
                <td>
                    <?php $controls->date('expire'); ?>
                </td>
            </tr>
            <tr valign="top">
                <th>Custom field</th>
                <td>
                    <?php if (!is_serialized($controls->options['custom'])) { ?>
                    <?php $controls->textarea('custom'); ?>
                    <?php } else { ?>
                    Serielized data!
                    <?php } ?>
                </td>
            </tr>
            <tr valign="top">
                <th>Unique token (used with API)</th>
                <td>
                    <?php $controls->text('token', 50); ?>
                    <div class="hints">If empty it will be regenerated.</div>
                </td>
            </tr>            
            <tr valign="top">
                <th>Amount</th>
                <td>
                    <?php $controls->text('amount', 10); ?> (in cents)
                </td>
            </tr>
            <tr valign="top">
                <th>Net amount</th>
                <td>
                    <?php $controls->text('net_amount', 10); ?> (in cents)
                </td>
            </tr>
            <tr valign="top">
                <th>Created</th>
                <td>
                    <?php echo $controls->options['created']; ?>
                </td>
            </tr>
        </table>
        <p class="submit">
            <?php $controls->button('save', 'Save'); ?>
        </p>
    </form>

    <h3>Notifications history</h3>
    <?php
    $ipns = $wpdb->get_results("select * from " . $wpdb->prefix . FILECOMMERCEPRO_TABLE_IPN . " where contractid=" .
            $controls->options[id] . " order by id desc");
    ?>
    <table class="widefat">
        <thead>
            <tr>
                <th>Id</th><th>Date</th><th>Gateway</th><th>Email</th><th>Full name</th><th>Transaction ID</th><th>Type</th>
            </tr>
        </thead>
        <tbody>
        <?php foreach ($ipns as $ipn) { ?>
        <?php $data = unserialize($ipn->data); ?>
        <tr>
            <td><?php echo $ipn->id; ?></td>
            <td><?php echo date('Y-m-d H:i:s', $ipn->created); ?></td>
            <td><?php echo $ipn->gateway; ?></td>
            <td>
            <?php
            switch ($ipn->gateway) {
                case 'paypal':
                    echo $data['address_name'];
                    break;
                case 'clickbank':
                    echo $data['ccustfullname'];
                    break;
            }
            ?>
            </td>
            <td>
            <?php
            switch ($ipn->gateway) {
                case 'paypal':
                    echo $data['payer_email'];
                    break;
                case 'clickbank':
                    echo $data['ccustemail'];
                    break;
            }
            ?>
            </td>
            <td>
            <?php
            switch ($ipn->gateway) {
                case 'paypal':
                    echo $data['txn_id'];
                    if (!empty($data['parent_txn_id'])) echo ' (' . $data['parent_txn_id'] . ')';
                    break;
                case 'clickbank':
                    echo $data['ctransreceipt'];
                    break;
            }
            ?>
            </td>ccustemail

            <td>
            <?php if ($ipn->gateway == 'paypal') { ?>
                <?php echo $data['payment_status']; ?>
            <?php } ?>

            <?php if ($ipn->gateway == 'clickbank') { ?>
                <?php echo $data['ctransaction']; ?>
            <?php } ?>
            </td>
        <?php } ?>
        </tbody>
    </table>
</div>

