<?php
// Questa file da chiamare direttamente permette di scatenare il download a fronte di 
// una chiave di contratto. La chiave del contratto è fatta dall'id del contratto e 
// dal token casuale separati dal trattino. La chiave va passata con il parametro "k".
// Il contratto identifica anche il file, ovviamente.
// 
// TODO: estendere in modo che accetto un id di file che sarà scaricabile se libero

include '../../../wp-load.php';

$file_commerce_pro->log_info('get.php');
$file_commerce_pro->log_debug($_GET);

list($contract_id, $contract_token) = split('-', trim($_REQUEST['k']));
if (empty($contract_token)) {
    die('Contract token not valid');
}

$contract = $wpdb->get_row($wpdb->prepare("select * from " . $wpdb->prefix . FILECOMMERCEPRO_TABLE_CONTRACTS .
                " where id=%s and token=%s and status = " .
                FileCommercePro::CONTRACT_VALID . " and expire > " . time() . " order by expire desc limit 1", $contract_id, $contract_token));

if ($contract) {
    $file = $file_commerce_pro->get_file($contract->fileid);
    $uploads = wp_upload_dir();
    $filepath = $uploads['basedir'] . '/' . FILECOMMERCEPRO_FILE_UPLOAD_DIR . $file->filename;

    if (!file_exists($filepath))
        die('File is missing, contact the administrator.');

    // Cleans up the file name
    $x = strpos($file->filename, '_');
    if ($x !== false) {
        $file->filename = substr($file->filename, $x + 1);
    }
    
    @$wpdb->query("update " . $wpdb->prefix . FILECOMMERCEPRO_TABLE_FILES . " set hits = hits+1 where id = " . $file->id);

    header("Cache-Control: public");
    header("Content-Type: " . $file->mime);
    header("Content-Description: File Transfer");
    header("Content-Disposition: attachment; filename= " . $file->filename);
    header("Content-Transfer-Encoding: binary");
    readfile($filepath);
    file_commerce_pro_update_file_hits($file->id);
    die();
}
else {
    die('No valid contract found');
}